unit DD77bestU1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TDD77bestF1 = class(TForm)
    laQuestion: TLabel;
    eUsersAnswer: TEdit;
    laMessages: TLabel;
    laUser: TLabel;
    laQsDone: TLabel;
    laScore: TLabel;
    buQuit: TButton;
    buSaveScore: TButton;
    laTxtQsDone: TLabel;
    laTxtScore: TLabel;
    laDebugAidWarning: TLabel;
    laDebugAidWarning2: TLabel;
    Label1: TLabel;
    procedure buQuitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure eUsersAnswerKeyPress(Sender: TObject; var Key: Char);
    procedure buSaveScoreClick(Sender: TObject);
  private
    { Private declarations }
    iScore:integer;//User's score
    bTmp, bQsDone:byte;//How many questions have been answered
    sTmp,sUserName,sRightAnswer:string;
    procedure GetID;
    procedure PrepQ;
    procedure SaveScore;
  public
    { Public declarations }
  end;

const ver='4 Apr 09';
//started 4 Apr 09

var
  DD77bestF1: TDD77bestF1;

implementation

{$R *.DFM}

procedure TDD77bestF1.GetID;
begin
if paramcount=0 then begin
sUserName:='FromHardCode';
//sUserName:=InputBox('GetID', 'User name?', '');
end //no ; here
else begin       
sUserName:=paramStr(1);
end;
laUser.caption:='User''s name: '+sUserName;
end;

procedure TDD77bestF1.PrepQ;
//Very crude!!!
begin
//Next pick the question, and put on screen...
//This is a very crude question picking algorithm, of
//   course, and the same question can be presented
//   twice in a row. But there is nothing in the design
//   of the program to prevent us from making the
//   question picking better. In fact, this tutorial
//   arises from a program I was working on in which
//   the computer keeps track of the user's success
//   on each individual question, and presents the user
//   with just the questions he/she needs to work on
//   See http://tinyurl.com/SheepdogOffers
//   (http://www.arunet.co.uk/tkboyd/offers.htm)
//   for software with such refinements.

bTmp:=random(5); //Will only return 0-4, inclusive
//Yes, and array and a Case statement would have done
//      the following better.
if bTmp=0 then begin
  laQuestion.caption:='What is the capital of England?';
  sRightAnswer:='l';//'London';
  end;
if bTmp=1 then begin
  laQuestion.caption:='What is the capital of Spain?';
  sRightAnswer:='m';//'Madrid';
  end;
if bTmp=2 then begin
  laQuestion.caption:='What is the capital of Germany?';
  sRightAnswer:='b';//'Berlin';
  end;
if bTmp=3 then begin
  laQuestion.caption:='What is the capital of the USA?';
  sRightAnswer:='w';//'Washington';
  end;
if bTmp=4 then begin
  laQuestion.caption:='What is the capital of Peru?';
  sRightAnswer:='l';//'Lima';
  end;

//Empty the edit box
eUsersAnswer.text:='';
//Enable it.
eUsersAnswer.enabled:=true;
end; //of FormCreate

procedure TDD77bestF1.FormCreate(Sender: TObject);
begin
randomize;
iScore:=0;//Start the user's score at zero.
bQsDone:=0;//Start the tally of how many questions answered at zero.
eUsersAnswer.enabled:=false;
eUsersAnswer.text:='';
laMessages.caption:='';
laQsDone.caption:='0';
laScore.caption:='0';
buSaveScore.enabled:=false;

GetID;
PrepQ;
end;

procedure TDD77bestF1.eUsersAnswerKeyPress(Sender: TObject;
  var Key: Char);
begin
if key=chr(13) then {has no else clause} begin //1a

   //Only for during debugging....
   sTmp:=eUsersAnswer.text;
   if length(sTmp)>1 then showmessage('For debugging, the "right" '+
      'answers have been set to just the first letter of the '+
      'real answer. And lower case will do.');
   eUsersAnswer.text:=lowercase(sTmp);
   //end of for during debugging

   if eUsersAnswer.text=sRightAnswer then begin //2a
   laMessages.caption:='Right! Good!';
   iScore:=iScore+20;
   inc(bQsDone);
   end//no ; here    2a
  else begin //2b
   laMessages.caption:='No. Answer was: '+sRightAnswer;
   inc(bQsDone);
   end;// 2b

if bQsDone<5 then PrepQ //no; here  (<5 because the count of q's
     //done goes up AFTER this point in the code.
  else buQuitClick(self);

laQsDone.caption:=inttostr(bQsDone);
laScore.caption:=inttostr(iScore);

PrepQ;
buSaveScore.enabled:=true;//only NEEDED once, but doing
   //repeatedly does no harm.

end;//1b
end;

procedure TDD77bestF1.buSaveScoreClick(Sender: TObject);
begin
buSaveScore.enabled:=false;
if bQsDone>0 then begin
  SaveScore;//Yes... you could do this MANY ways.
       //This one is least distracting, I hope
       //the tutorial is about the state diagrams,
       //not all the various ways of splitting up
       //code, of connecting the bits, of parameter
       //passing and scope, etc
       //
  end;//user had done at least one question.
end;

procedure TDD77bestF1.SaveScore;
//Very, very crude. Saves a text file called Score.txt
//Any previously existing Score.txt is wiped out without
//   any question ("Do you want to...?") being raised.
//
//For a tutorial on this sort of file writing, see...
//http://sheepdogguides.com/dt2q.htm
//          ... and others, which you can get to from there.
var dfOut:textfile;
begin
assignfile(dfOut,'Score.txt');
rewrite(dfOut);
sTmp:=sUserName+' made a score of '+inttostr(iScore);
writeln(dfOut,sTmp);
closefile(dfOut);
end;

procedure TDD77bestF1.buQuitClick(Sender: TObject);
begin
if buSaveScore.enabled=true then buSaveScoreClick(self);
application.terminate;
end;

end.
